
Ahoy.DoingIslandExpedition = false;
Ahoy.IslandsMapOpen = false;
Ahoy.WindowClosedDuringQueue = false;
Ahoy.WindowClosedOutsideExpedition = false;
Ahoy.CorrectlyQueued = false;
Ahoy.InQueue = false;
Ahoy.Score = {};
Ahoy.RareScore = {};
Ahoy.EntriesCount = 0;
Ahoy.waitTable = {};
Ahoy.waitFrame = nil;

function Ahoy__wait(delay, func, ...)
	if(type(delay)~="number" or type(func)~="function") then
	return false;
	end
	if(Ahoy.waitFrame == nil) then
	Ahoy.waitFrame = CreateFrame("Frame","Ahoy.waitFrame", UIParent);
	Ahoy.waitFrame:SetScript("onUpdate",function (self,elapse)
		local count = #Ahoy.waitTable;
		local i = 1;
		while(i<=count) do
		local waitRecord = tremove(Ahoy.waitTable,i);
		local d = tremove(waitRecord,1);
		local f = tremove(waitRecord,1);
		local p = tremove(waitRecord,1);
		if(d>elapse) then
			tinsert(Ahoy.waitTable,i,{d-elapse,f,p});
			i = i + 1;
		else
			count = count - 1;
			f(unpack(p));
		end
		end
	end);
	end
	tinsert(Ahoy.waitTable,{delay,func,{...}});
	return true;
end

local function splits(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

function AhoyResetVariables()
	Ahoy.EntriesCount = 0;
	Ahoy.Score = {};
	Ahoy.RareScore = {};
	Ahoy.DoingIslandExpedition = false;
	Ahoy.InQueue = false;
	ClearTabSelect();
	for variable = 0, 16, 1 do
		child1, child2, child3, child4 = Ahoy.TabFrames[variable]:GetChildren()
		child1.text:SetText(format(" "))
		child2.text:SetText(format(" "))
		child3:Hide();
		child4.text:SetText(format(" "))
	end
	AhoyLootContentFrame.text:SetText("")
	Ahoy_AdjustTabs(-1);
end

local function shallowcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[orig_key] = orig_value
        end
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

local function UpdateScore ()
	currentTab = 0;
	Ahoy.ScoreCopy = shallowcopy(Ahoy.Score);
	for variable = 0, Ahoy.EntriesCount, 1 do
		highestValue = 0;
		highestKey = " ";
		for k, v in pairs(Ahoy.ScoreCopy) do
			if k ~= "NPC" and k ~= "Ignore" and k ~= "PvP" and currentTab < 16 then
				if v > highestValue then
					highestValue = v;
					highestKey = k;
				end
			end
		end
		if highestKey ~= " " then
			child1, child2, child3, child4 = Ahoy.TabFrames[currentTab]:GetChildren()
			child1.text:SetText(format(highestKey))
			child2.text:SetText(format(Ahoy.ScoreCopy[highestKey] .. "    "))
			if Ahoy.RareScore[highestKey] > 0 then
				child3:Show();
				child4.text:SetText(format(Ahoy.RareScore[highestKey] .. "x"))
			else
				child3:Hide();
				child4.text:SetText(format(" "));
			end
			Ahoy.ScoreCopy[highestKey] = 0;
			currentTab = currentTab + 1;
		end
	end
	-- exclude showing tabs for ignored keys --
	local excludeCount = 0;
	if Ahoy.ScoreCopy["NPC"] ~= nil then
		excludeCount = excludeCount + 1;
	end
	if Ahoy.ScoreCopy["Ignore"] ~= nil then
		excludeCount = excludeCount + 1;
	end
	if Ahoy.ScoreCopy["PvP"] ~= nil then
		excludeCount = excludeCount + 1;
	end
	-- show/hide needed tab frames
	Ahoy_AdjustTabs(Ahoy.EntriesCount - 1 - excludeCount);
end

function Ahoy_AzeriteGain(guid, gain)
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid);
	if type == "Creature" then
	npcRaw = AhoyCreatureDB[tonumber(npc_id)];
		if npcRaw ~= nil then
			local npcData = splits(npcRaw,"|");
			local npcClass = npcData[4];
			if npcClass ~= nil then
				if Ahoy.Score[npcClass] == nil then				-- is it a new entry?
					Ahoy.Score[npcClass] = 0;						-- reset entry score to 0
					Ahoy.RareScore[npcClass] = 0;
					Ahoy.EntriesCount = Ahoy.EntriesCount + 1;		-- increase count
				end
			end
			Ahoy.Score[npcClass] = Ahoy.Score[npcClass] + gain;
			if npcData[3] == "Rare" or npcData[3] == "Rare Elite" then
				Ahoy.RareScore[npcClass] = Ahoy.RareScore[npcClass] + 1;
			end
			UpdateScore();
		else
			print("[ Missing ID : " .. npc_id .. " ]");
		end
	end
end

function Ahoy_ClickedTab(tabNumber)
	local lootString = ""
	child1, child2, child3, child4 = Ahoy.TabFrames[tabNumber]:GetChildren();
	local selectedCreatureClass = child1.text:GetText();
	if AhoyItemDB[selectedCreatureClass] ~= nil then
		lootString = AhoyItemDB[selectedCreatureClass];
	else
		lootString = "Error : Missing Entry in AhoyItemDB.lua : " .. selectedCreatureClass;
	end
	local itemLink =  selectedCreatureClass .. "\n" .. lootString
	AhoyLootContentFrame.text:SetText(itemLink);
	local height = AhoyLootContentFrame.text:GetStringHeight();
	AhoyLootContentFrame:SetHeight(height);
	AhoyLootScrollbar:SetMinMaxValues(-1, height/2) 
end

function Ahoy_SelectedCreature(guid)
	ClearTabSelect();
	if guid ~= nil then
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid);
		if type == "Creature" then
			npcRaw = AhoyCreatureDB[tonumber(npc_id)];
			if npcRaw ~= nil then
				local npcData = splits(npcRaw,"|");
				local npcClass = npcData[4];
				if AhoyItemDB[npcClass] ~= nil then
					lootString = AhoyItemDB[npcClass];
				else
					lootString = " " .. npcClass;
				end
				local itemLink = "Target: " .. npcClass .. "\n" .. lootString
				AhoyLootContentFrame.text:SetText(itemLink);
				local height = AhoyLootContentFrame.text:GetStringHeight();
				AhoyLootContentFrame:SetHeight(height);
				AhoyLootScrollbar:SetMinMaxValues(-1, height/2) 
			end
		end
	else
		if Ahoy.selectedTab == -1 then
			AhoyLootContentFrame.text:SetText(" ");
		end
	end
end

function Ahoy_LoadRewards()
	local name, typeID, subtypeID, iconTextureFile, moneyBase, moneyVar, experienceBase, experienceVar, numStrangers, numRewards = GetLFGCompletionReward();
	if numRewards == nil or numRewards == 0 then
		--print ("No Rewards");
	else
		Ahoy_UpdateRewardsUI(numRewards);
	end
end

function Ahoy_VerifyCorrectQueue()
	local correctQueue = false;
	local LFGInfo = C_LFGInfo.GetAllEntriesForCategory(LE_LFG_CATEGORY_SCENARIO);
	local instanceMapID = LFGInfo[1];
	local IslandDifficultyInfo = C_IslandsQueue.GetIslandDifficultyInfo()
	for idi = 0, getn(IslandDifficultyInfo), 1 do
		local entry = IslandDifficultyInfo[idi];
		if entry ~= nil then
			if entry.difficultyId == instanceMapID then
				correctQueue = true
			end
		end
	end
	return correctQueue;
end

----------------------------------------
---------------- Events ----------------
----------------------------------------
-- LFG UPDATE
local LFG_UPDATE_EVENT = CreateFrame("FRAME", UIParent);
LFG_UPDATE_EVENT:RegisterEvent("LFG_UPDATE");
local function eventHandler(self, event)
	local x,y = GetLFGMode(LE_LFG_CATEGORY_SCENARIO);
	--print (tostring(x) .. " " .. tostring(y));
	if x == nil then
		Ahoy_WindowSwitch("Splashscreen");
		if Ahoy.IslandsMapOpen then
			if Ahoy.WindowClosedOutsideExpedition == false and Ahoy.WindowClosedDuringQueue == false then
				Ahoy_OpenMainframe()
			end
		else
			Ahoy_CloseMainframe()
		end
	end
	if x == "lfgparty" and Ahoy.CorrectlyQueued then
		---- Entered Island ----
		if Ahoy_Settings_New.Toggle_AutoShowAhoyOnIsland == true then
			Ahoy_OpenMainframe()
		end
		Ahoy_WindowSwitch("Expedition");
		Ahoy.DoingIslandExpedition = true;
	end
end
LFG_UPDATE_EVENT:SetScript("OnEvent", eventHandler);


-- LFG QUEUE STATUS UPDATE
local LFG_QUEUE_STATUS_UPDATE_EVENT = CreateFrame("FRAME", UIParent);
LFG_QUEUE_STATUS_UPDATE_EVENT:RegisterEvent("LFG_QUEUE_STATUS_UPDATE");
local function eventHandler(self, event)
	local x,y = GetLFGMode(LE_LFG_CATEGORY_SCENARIO);
	--print (tostring(x) .. " " .. tostring(y));
	if x == "queued" and Ahoy_VerifyCorrectQueue() then
		Ahoy.InQueue = true;
		Ahoy.CorrectlyQueued = true;
		Ahoy_WindowSwitch("Queue");
		if Ahoy_Settings_New.Toggle_AutoShowAhoyOnMissionTable == true then
			if Ahoy.WindowClosedOutsideExpedition == false and Ahoy.WindowClosedDuringQueue == false then
				Ahoy_OpenMainframe()
			end
		end
		AhoyResetVariables()
	else
		Ahoy.InQueue = false;
		Ahoy.WindowClosedDuringQueue = false;
		if Ahoy.IslandsMapOpen == true then
			Ahoy_WindowSwitch("Splashscreen");
		end
	end
end
LFG_QUEUE_STATUS_UPDATE_EVENT:SetScript("OnEvent", eventHandler);

--ISLANDS_QUEUE_OPEN
local ISLANDS_QUEUE_OPEN_EVENT = CreateFrame("FRAME", UIParent);
ISLANDS_QUEUE_OPEN_EVENT:RegisterEvent("ISLANDS_QUEUE_OPEN");
local function eventHandler(self, event)
	if Ahoy_Settings_New.Toggle_AutoShowAhoyOnMissionTable == true then
		Ahoy_OpenMainframe()
	end
	Ahoy.IslandsMapOpen = true;
	Ahoy.WindowClosedOutsideExpedition = false;
	Ahoy.WindowClosedDuringQueue = false;
	local x,y = GetLFGMode(LE_LFG_CATEGORY_SCENARIO);
	if x == "queued" then
		Ahoy_WindowSwitch("Queue");
		Ahoy.InQueue = true;
	else
		Ahoy_WindowSwitch("Splashscreen");
		Ahoy.InQueue = false;
		Ahoy.WindowClosedDuringQueue = false;
	end
end
ISLANDS_QUEUE_OPEN_EVENT:SetScript("OnEvent", eventHandler);

--ISLANDS_QUEUE_CLOSE
local ISLANDS_QUEUE_CLOSE_EVENT = CreateFrame("FRAME", UIParent);
ISLANDS_QUEUE_CLOSE_EVENT:RegisterEvent("ISLANDS_QUEUE_CLOSE");
local function eventHandler(self, event)
	local x,y = GetLFGMode(LE_LFG_CATEGORY_SCENARIO);
	if x == "queued" then
		Ahoy.IslandsMapOpen = true;
		Ahoy_WindowSwitch("Queue");
	else
		Ahoy.IslandsMapOpen = false;
		Ahoy_CloseMainframe()
	end
end
ISLANDS_QUEUE_CLOSE_EVENT:SetScript("OnEvent", eventHandler);

-- Finish Expedition --
local LFG_COMPLETION_REWARD_EVENT = CreateFrame("FRAME", UIParent);
LFG_COMPLETION_REWARD_EVENT:RegisterEvent("LFG_COMPLETION_REWARD");
local function eventHandler(self, event)
	if Ahoy.DoingIslandExpedition == true then
		Ahoy.DoingIslandExpedition = false;
		if Ahoy_Settings_New.Toggle_ShowRewards == true then
			Ahoy__wait(1,Ahoy_LoadRewards);
		end
	end
end
LFG_COMPLETION_REWARD_EVENT:SetScript("OnEvent", eventHandler);

-- LFG Completion Reward --
local FINISHED_EXPEDITION_EVENT = CreateFrame("FRAME", UIParent);
FINISHED_EXPEDITION_EVENT:RegisterEvent("ISLAND_COMPLETED");
local function eventHandler(self, event, mapID, winner)
	if Ahoy_Settings_New.Toggle_ShowRewards == true then
		Ahoy_WindowSwitch("Rewards");
		Ahoy.CorrectlyQueued = false;
	end
end
FINISHED_EXPEDITION_EVENT:SetScript("OnEvent", eventHandler);

-- Player Targeted Mob --
local function Ahoy_MobTargeted()
	local guid = UnitGUID("target")
	Ahoy_SelectedCreature(guid);
end

local PLAYER_TARGET_CHANGED_EVENT = CreateFrame("FRAME", UIParent);
PLAYER_TARGET_CHANGED_EVENT:RegisterEvent("PLAYER_TARGET_CHANGED");
local function eventHandler(self, event, mapID, winner)
	if Ahoy.DoingIslandExpedition == true then
		if Ahoy_Settings_New.Toggle_MobTargetLootDisplay == true then
			Ahoy_MobTargeted()
		end
	end
end
PLAYER_TARGET_CHANGED_EVENT:SetScript("OnEvent", eventHandler);

-- Mouse Over --
local UPDATE_MOUSEOVER_UNIT_EVENT = CreateFrame("FRAME", UIParent);
UPDATE_MOUSEOVER_UNIT_EVENT:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
local function eventHandler(self, event, ...)
	if Ahoy.DoingIslandExpedition then
		if Ahoy_Settings_New.Toggle_MobMouseOverCategory == true then
			local guid, name = UnitGUID("mouseover"), UnitName("mouseover")
			local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid);
			npcRaw = AhoyCreatureDB[tonumber(npc_id)];
			if npcRaw ~= nil then
				npcData = splits(npcRaw,"|");
				GameTooltip:AddLine("Ahoy: " .. npcData[4], 1, 1, 1)
				GameTooltip:Show()
			end
		end
	end
end
UPDATE_MOUSEOVER_UNIT_EVENT:SetScript("OnEvent", eventHandler);

-- Azerite Gain --
local AHOY_AZERITE_GAIN_EVENT = CreateFrame("FRAME", UIParent);
AHOY_AZERITE_GAIN_EVENT:RegisterEvent("ISLAND_AZERITE_GAIN");
local function eventHandler(self, event, amount, gainedByPlayer, factionIndex, gainedBy, gainedFrom)
	if Ahoy.DoingIslandExpedition then
		Ahoy_AzeriteGain(gainedFrom, amount);
	end
end
AHOY_AZERITE_GAIN_EVENT:SetScript("OnEvent", eventHandler);

-- Variables loaded event --
local AHOY_LOGIN_EVENT = CreateFrame("Frame","VARIABLES_LOADED",UIParent)
AHOY_LOGIN_EVENT:RegisterEvent("VARIABLES_LOADED");
AHOY_LOGIN_EVENT:SetScript("OnEvent",
function(self,event,...)
	if event=="VARIABLES_LOADED" then
		Ahoy_LoadSettings()
		Ahoy_MoveToSavedPosition()
		Ahoy_MinimapButton_Reposition()
		Ahoy_SetToggleDefaults();
	end
end)

--[[
local ALLEVENTS_DEBUG = CreateFrame("FRAME", UIParent);
ALLEVENTS_DEBUG:RegisterAllEvents();
local function eventHandler(self, event)
	print (event);
end
ALLEVENTS_DEBUG:SetScript("OnEvent", eventHandler);
--]]